package processUtils;

import io.ResultOutput;

import java.util.Iterator;
import java.util.TreeMap;

import units.BinaryTree;
import units.GeneFamily;
import units.Matrix;
import units.Node;

public class WeightedParsimony {

	private BinaryTree tree;
	private TreeMap<String, GeneFamily> families;
	private Matrix matrix;
	private ResultOutput results;
	
	public WeightedParsimony(BinaryTree tree, TreeMap<String, GeneFamily> families, Matrix matrix, String outputFile){
		this.tree = tree;
		this.families = families;
		this.matrix = matrix;
		this.results = new ResultOutput(outputFile);
	}
	
	public void calculateParsimony(){
		Iterator<String> it = families.keySet().iterator();
		while(it.hasNext()){
			String familyID = it.next();
			GeneFamily geneFamily = families.get(familyID);
			
			this.tree.setLeafDuplicates(geneFamily, this.matrix.getLength());
			
			this.tree.setRValues(this.matrix);
			
			this.tree.setFamilySizeTies();
			
			this.tree.setFamilySize(this.matrix);
			
			this.results.outputResult(this.tree, familyID);
			
			tree.clear();
		}
	}
}
