package units;

import java.util.ArrayList;

public  class Node {
	 
	  private ArrayList<Node> descendents = new ArrayList<Node>();
	  private Node ancestor;
	  private String newick;
	  private String name;
	  private R rValues;
	  private double distFromParent;
	  private boolean root;
	  private int bootval;
	  private int familySize;
	  
	  private ArrayList<Integer> potentialFamilySizes = new ArrayList<Integer>();

	  public Node(double branchLength){
		  this.distFromParent = branchLength;
		  this.rValues = new R();
	  }
	  
	  public R getRValues(){
		  return this.rValues;
	  }
	  
	  public void clearRValues(){
		  this.rValues.clear();
	  }
	  
	  public void setFamilySize(int familySize){
		  this.familySize = familySize;
	  }
	  
	  public int getFamilySize(){
		  return this.familySize;
	  }
	  
	  public void setBoot(int bootval){
		  this.bootval = bootval;
	  }
	  public int getBoot(){
		  return this.bootval;
	  }
	  
	  public ArrayList<Integer> getPotentialFamilySizes(){
		  return this.potentialFamilySizes;
	  }
	    
	  public int getPotentialFamilySize(int i){
		  return this.potentialFamilySizes.get(i);
	  }
	  public void setPotentialFamilySizes(ArrayList<Integer> potentialFamilySizes){
		  this.potentialFamilySizes = potentialFamilySizes;
	  }
	  public void setCopyNumber(int size){
		  this.potentialFamilySizes.add(size);
	  }
	  public void setPotentialFamilySize(int i, int size){
		  this.potentialFamilySizes.add(i, size);
	  }
	  public void clearPotentialFamilySizes(){
		  this.potentialFamilySizes.clear();
	  }
	  
	  public ArrayList<Node> getDescendents(){
		  return descendents;
	  }
	  
	  public void setNewick(String newick){
		  this.newick = newick;
	  }
	  
	  public String getNewick(){
		  return newick;
	  }
	  
	  public Node getLastDescendent(){
		  return descendents.get(descendents.size()-1);
	  }
	  
	  public Node getAncestor(){
		  return ancestor;
	  }
	  
	  public void addDescendent(Node node){
		  descendents.add(node);
	  }
	  
	  public String getName(){
		  return name;
	  }
	  
	  public void setName(String name){
		  this.name = name;
	  }
	  
	  public void setRoot(boolean root){
		  this.root = root;
	  }
	  
	  public boolean isRoot(){
		  return root;
	  }
	  
	  public boolean isLeaf(){
		  if(descendents.isEmpty()){
			  return true;
		  }else{
			  return false;
		  }
	  }
}
